import xml.etree.ElementTree as etree
import urllib.request
import pygame
from math import *

def draw(screen,xd,yd,zd,server,port):              #prekresleni mapy
    image = []
    for y in range(3):
        for x in range(3):
            try:
                urllib.request.urlretrieve("http://"+server+":"+str(port)+"/"+str(zd)+"/"+str(xd+x-1)+"/"+str(yd+y-1)+".jpg","image.jpg")  #ukladani obrazku do mezisouboru 
                image.append(pygame.image.load("image.jpg"))    #vytvoreni a ulozeni Surface do listu dlazdic
            except urllib.error.HTTPError or urllib.error.URLError:
                image.append(pygame.Surface((256,256)))         #pokud obrazek neexistuje, bude tam cerne misto
            screen.blit(image[-1],(256*x,256*y,256,256)) 
            pygame.display.flip()
    

class Obce:
    def __init__(self,obec,server,port):
        tree = etree.parse(urllib.request.urlopen("http://"+server+":"+str(port)+"/obce.xml"))      #parsovani XML
        self.root = tree.getroot()
        self.listobec = []              
        volba = 0
        for obj in self.root:                   #vyhledavani obce
            if obj.attrib["jméno"] == obec:
                self.listobec.append(obj)
        if len(self.listobec) == 0:
            print("Obec nenalezena")
        if len(self.listobec) > 1:
            print("Pocet obci:"+str(len(self.listobec))+".")                
            volba = int(input("Zadejte cislo od 1 do "+str(len(self.listobec)))) - 1                #zobrazovani na stredu
        zd = int(input("Zadejte priblizeni od 0 do 9:"))                
        xd = int(float(self.listobec[volba].attrib["x"])/ 256 / 2**(9-zd))
        yd = int(float(self.listobec[volba].attrib["y"])/ 256 / 2**(9-zd))
        modx = 256*(float(self.listobec[volba].attrib["x"])%256 / 2**(9-zd) - int(float(self.listobec[volba].attrib["x"])%256 / 2**(9-zd)))
        mody = 256*(float(self.listobec[volba].attrib["y"])%256 / 2**(9-zd) - int(float(self.listobec[volba].attrib["y"])%256 / 2**(9-zd)))
        screen = pygame.display.set_mode((1000,768))
        image = []
        buffer = pygame.Surface((256*5,256*5))
        for y in range(5):
            for x in range(5):
                try:
                    urllib.request.urlretrieve("http://"+server+":"+str(port)+"/"+str(zd)+"/"+str(xd+x-2)+"/"+str(yd+y-2)+".jpg","image.jpg")  #ukladani obrazku do mezisouboru 
                    image.append(pygame.image.load("image.jpg"))    #vytvoreni a ulozeni Surface do listu dlazdic
                except urllib.error.HTTPError or urllib.error.URLError:
                    image.append(pygame.Surface((256,256)))         #pokud obrazek neexistuje, bude tam cerne misto
                buffer.blit(image[-1],(256*x,256*y,256,256)) 
        screen.blit(buffer,(0,0,896,896),(128+modx,128+mody,768,768))
        pygame.font.init()
        screen.blit(pygame.font.SysFont("sans-serif",25).render("Zmerit vzdalenost - Z",2,(255,255,255)),(800,100,200,100))
        pygame.display.flip()   
        while True:
            event = pygame.event.poll()
            if event.type == pygame.QUIT:
                exit()
            if event.type == pygame.KEYDOWN:
                if event.key == pygame.K_z:
                    self.klik(self.listobec[volba],screen)
                if event.key == pygame.K_UP:
                    yd -= 1
                    draw(screen,xd,yd,zd,server,port)
                if event.key == pygame.K_RIGHT:
                    xd += 1
                    draw(screen,xd,yd,zd,server,port)
                if event.key == pygame.K_DOWN:
                    yd += 1
                    draw(screen,xd,yd,zd,server,port)
                if event.key == pygame.K_LEFT:
                    xd -= 1
                    draw(screen,xd,yd,zd,server,port)
                if event.key == pygame.K_KP_PLUS:
                    zd += 1
                    xd = xd*2
                    yd = yd*2
                    draw(screen,xd,yd,zd,server,port)
                if event.key == pygame.K_KP_MINUS:
                    zd -= 1
                    xd = int(xd/2)
                    yd = int(yd/2)
                    draw(screen,xd,yd,zd,server,port)
    def klik(self,obec,screen):
        while True:
            event = pygame.event.wait()
            if event.type == pygame.MOUSEBUTTONDOWN:        #klikani mysi
                xpos = pygame.mouse.get_pos()[0]
                ypos = pygame.mouse.get_pos()[1]
                break
            if event.type == pygame.QUIT:
                exit()
        nejblizsiobce = [self.root[0]]
        for obj in self.root:
            vzdalenost = sqrt(int(int(obj.attrib["x"]))**2+int(obj.attrib["y"]))                #Pythagorova veta
            for x in range(len(nejblizsiobce)):
                if vzdalenost < sqrt(int(int(nejblizsiobce[x].attrib["x"])**2+int(nejblizsiobce[x].attrib["y"]))):
                    nejblizsiobce.insert(x,obj)     
        for x in range(9):
            screen.blit(pygame.font.SysFont("sans-serif",25).render(nejblizsiobce.attrib["jméno"],2,(255,255,255),(800,100+x*70,200,70))) #Zobrazeni nejblizsich obci 